/******/ (function() { // webpackBootstrap
/******/ 	"use strict";
/******/ 	// The require scope
/******/ 	var __webpack_require__ = {};
/******/ 	
/************************************************************************/
/******/ 	/* webpack/runtime/define property getters */
/******/ 	!function() {
/******/ 		// define getter functions for harmony exports
/******/ 		__webpack_require__.d = function(exports, definition) {
/******/ 			for(var key in definition) {
/******/ 				if(__webpack_require__.o(definition, key) && !__webpack_require__.o(exports, key)) {
/******/ 					Object.defineProperty(exports, key, { enumerable: true, get: definition[key] });
/******/ 				}
/******/ 			}
/******/ 		};
/******/ 	}();
/******/ 	
/******/ 	/* webpack/runtime/hasOwnProperty shorthand */
/******/ 	!function() {
/******/ 		__webpack_require__.o = function(obj, prop) { return Object.prototype.hasOwnProperty.call(obj, prop); }
/******/ 	}();
/******/ 	
/******/ 	/* webpack/runtime/make namespace object */
/******/ 	!function() {
/******/ 		// define __esModule on exports
/******/ 		__webpack_require__.r = function(exports) {
/******/ 			if(typeof Symbol !== 'undefined' && Symbol.toStringTag) {
/******/ 				Object.defineProperty(exports, Symbol.toStringTag, { value: 'Module' });
/******/ 			}
/******/ 			Object.defineProperty(exports, '__esModule', { value: true });
/******/ 		};
/******/ 	}();
/******/ 	
/******/ 	/* webpack/runtime/publicPath */
/******/ 	!function() {
/******/ 		__webpack_require__.p = "";
/******/ 	}();
/******/ 	
/************************************************************************/
var __webpack_exports__ = {};
// ESM COMPAT FLAG
__webpack_require__.r(__webpack_exports__);

// EXPORTS
__webpack_require__.d(__webpack_exports__, {
  CSVBoxButton: function() { return /* reexport */ CSVBoxButton; }
});

;// CONCATENATED MODULE: ./node_modules/@vue/cli-service/lib/commands/build/setPublicPath.js
/* eslint-disable no-var */
// This file is imported into lib/wc client bundles.

if (typeof window !== 'undefined') {
  var currentScript = window.document.currentScript
  if (false) { var getCurrentScript; }

  var src = currentScript && currentScript.src.match(/(.+\/)[^/]+\.js(\?.*)?$/)
  if (src) {
    __webpack_require__.p = src[1] // eslint-disable-line
  }
}

// Indicate to webpack that this file can be concatenated
/* harmony default export */ var setPublicPath = (null);

;// CONCATENATED MODULE: ./node_modules/@vue/vue-loader-v15/lib/loaders/templateLoader.js??vue-loader-options!./node_modules/@vue/vue-loader-v15/lib/index.js??vue-loader-options!./src/CSVBoxButton.vue?vue&type=template&id=22e9acda&scoped=true
var render = function () {var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;return _c('div',[_c('button',{attrs:{"disabled":_vm.disableImportButton},on:{"click":function($event){$event.preventDefault();return _vm.openModal.apply(null, arguments)}}},[_vm._t("default")],2),_c('div',{ref:"holder",staticClass:"holder-style"})])}
var staticRenderFns = []


;// CONCATENATED MODULE: ./package.json
var package_namespaceObject = {"rE":"0.0.0"};
;// CONCATENATED MODULE: ./node_modules/@vue/vue-loader-v15/lib/index.js??vue-loader-options!./src/CSVBoxButton.vue?vue&type=script&lang=js
//
//
//
//
//
//
//
//


    
    // import { Logger } from "./../utils/Logger";

    /* harmony default export */ var CSVBoxButtonvue_type_script_lang_js = ({
        name: 'csvbox-button',
        props: {
            licenseKey: {
                type: String,
                required: true
            },
            onImport: {
                type: Function,
                default: function() {}
            },
            onReady: {
                type: Function,
                default: function() {}
            },
            onSubmit: {
                type: Function,
                default: function() {}
            },
            onClose:{
                type: Function,
                default: function() {}
            },
            user: {
                type: Object,
                default: function () {
                    return { user_id: 'default123' };
                }
            },
            dynamicColumns: {
                type: Array,
                default: function () {
                    return null;
                }
            },
            options: {
                type: Object,
                default: function () {
                    return { user_id: 'default123' };
                }
            },
            dataLocation: {
                type: String,
                required: false
            },
            customDomain: {
                type: String,
                required: false
            },
            debug: {
                type: String,
                required: false,
                default: null
            },
            language: {
                type: String,
                required: false
            },
            lazy: {
                type: Boolean,
                required: false,
                default: false
            },
            loadStarted: {
                type: Function,
                default: function() {}
            },
            environment: {
                type: Object,
                default: function () {
                    return null;
                }
            },
        },
        computed:{
            iframeSrc() {
                let domain = this.customDomain ? this.customDomain : "app.csvbox.io";
                if(this.dataLocation) { 
                    domain = `${this.dataLocation}-${domain}`;
                }

                let iframeUrl = `https://${domain}/embed/${this.licenseKey}`;
                iframeUrl += `?library-version=${package_namespaceObject.rE}`;
                iframeUrl += "&framework=vue";
                if(this.dataLocation) {
                    iframeUrl += "&preventRedirect";
                }
                if(this.language) {
                    iframeUrl += "&language=" + this.language;
                }

                if(this.environment) {
                    let environment = JSON.stringify(this.environment).replace(/['"]/g, function(match) {
                        return '\\' + match;
                    });
                    iframeUrl += `&env=${environment}`;
                }

                return iframeUrl;
            }
        },
        data(){
            return {
                isModalShown: false,
                disableImportButton: true,
                uuid: this._uid + '_' + Math.random().toString(36).substring(2, 15) + Math.random().toString(36).substring(2, 15),
                // logger: new Logger(this.debug),
                iframe: null,
                isIframeLoaded: false,
                openModalOnIframeLoad: false,
            }
        },
        methods: {
            openModal() {

                if(this.lazy) {
                    if(!this.iframe) {
                        this.openModalOnIframeLoad = true;
                        this.initImporter();
                        return;
                    }
                }
                
                // this.logger.info("openModal();");
                
                if(!this.isModalShown) {
                    if(this.isIframeLoaded) {
                        // this.logger.verbose("Opening importer modal");
                        this.isModalShown = true;
                        this.$refs.holder.style.display = 'block';
                        this.iframe.contentWindow.postMessage('openModal', '*');
                    } else {
                        this.openModalOnIframeLoad = true;
                    }                    
                }else{
                    // this.logger.verbose("Modal already showing or shown");
                }
                
            },
            onMessageEvent(event) {
                if (event.data === "mainModalHidden") {
                    this.$refs.holder.style.display = 'none';
                    this.isModalShown = false;
                    this.onClose();
                }
                if(event.data === "uploadSuccessful") {
                    this.onImport(true);
                }
                if(event.data === "uploadFailed") {
                    this.onImport(false);
                }
                if(typeof event.data == "object") {
                    if(event?.data?.data?.unique_token == this.uuid) {

                        // this.logger.verbose("Event:", `'${event.data.type}'`, event.data.data);

                        if(event.data.type && event.data.type == "data-on-submit") {
                            let metadata = event.data.data;
                            metadata["column_mappings"] = event.data.column_mapping;
                            delete metadata["unique_token"];
                            this.onSubmit?.(metadata);
                        }
                        else if(event.data.type && event.data.type == "data-push-status") {
                            if(event.data.data.import_status == "success") {
                                if(event.data && event.data.row_data) {
                                    let primary_row_data = event.data.row_data;
                                    let headers = event.data.headers;
                                    let rows = [];
                                    let dynamic_columns_indexes = event.data.dynamicColumnsIndexes;
                                    let virtual_columns_indexes = event.data.virtualColumnsIndexes || [];

                                    let dropdown_display_labels_mappings = event.data.dropdown_display_labels_mappings;
                                    primary_row_data.forEach((row_data) => {
                                        
                                        let x = {};
                                        let dynamic_columns = {};
                                        let virtual_data = {};
                                        
                                        row_data.data.forEach((col, i)=>{
                                            if(col == undefined){ col = "" }
                                            if(!!dropdown_display_labels_mappings[i] && !!dropdown_display_labels_mappings[i][col]) {
                                                col = dropdown_display_labels_mappings[i][col];
                                            }
                                            if(dynamic_columns_indexes.includes(i)) {
                                                dynamic_columns[headers[i]] = col;
                                            }
                                            else if(virtual_columns_indexes.includes(i)) {
                                                virtual_data[headers[i]] = col;
                                            }
                                            else{
                                                x[headers[i]] = col;
                                            }
                                        });

                                        if(row_data.unmapped_data) {
                                            x["_unmapped_data"] = row_data.unmapped_data;
                                        }
                                        if(dynamic_columns && Object.keys(dynamic_columns).length > 0) {
                                            x["_dynamic_data"] = dynamic_columns;
                                        }
                                        if(virtual_data && Object.keys(virtual_data).length > 0) {
                                            x["_virtual_data"] = virtual_data;
                                        }

                                        rows.push(x);
                                    });
                                    let metadata = event.data.data;
                                    metadata["rows"] = rows;
                                    metadata["column_mappings"] = event.data.column_mapping;
                                    metadata["raw_columns"] = event.data.raw_columns;
                                    metadata["ignored_columns"] = event.data.ignored_column_row;
                                    delete metadata["unique_token"];
                                    this.onImport(true, metadata);
                                }else{
                                    let metadata = event.data.data;
                                    delete metadata["unique_token"];
                                    this.onImport(true, metadata);
                                }
                            } else {
                                this.onImport(false, event.data.data);
                            }
                        }else if(event.data.type && event.data.type == "csvbox-modal-hidden") {
                            this.$refs.holder.style.display = 'none';
                            this.isModalShown = false;
                            this.onClose();
                        } else if(event.data.type && event.data.type == "csvbox-upload-successful") {
                            this.onImport(true);
                        } else if(event.data.type && event.data.type == "csvbox-upload-failed") {
                            this.onImport(false);
                        }
                    }
                }
            },
            initImporter() {
                this.loadStarted();
                // this.logger.info("Framework:", "Vue");
                // this.logger.info("Library version:", version);
                if(this.customDomain){
                    // this.logger.info("Using domain:", this.customDomain);
                }
                if(this.dataLocation) {
                    // this.logger.info("Data location:", this.dataLocation);
                }
                // this.logger.info("Importer url:", this.iframeSrc);

                let iframe = document.createElement("iframe");
                this.iframe = iframe;
                iframe.setAttribute("src", this.iframeSrc);
                iframe.frameBorder = 0;
                iframe.classList.add('csvbox-iframe');

                window.addEventListener("message", this.onMessageEvent, false);

                let self = this;

                iframe.onload = function () {
                    self.isIframeLoaded = true;
                    // self.logger.info("Importer ready");
                    iframe.contentWindow.postMessage({
                        "customer" : self.user ? self.user : null,
                        "columns" : self.dynamicColumns ? self.dynamicColumns : null,
                        "options" : self.options ? self.options : null,
                        "unique_token": self.uuid
                    }, "*");
                    self.disableImportButton = false;
                    self.onReady();
                    if(self.openModalOnIframeLoad) {
                        self.openModal();
                    }
                }

                this.$refs.holder.appendChild(iframe);

            }
        },
        mounted() {
            if(this.lazy) {
                this.disableImportButton = false;
            } else {
                this.initImporter();
            }
            
        },
        beforeDestroy() {
            // this.logger.verbose("Removing message event listener");
            window.removeEventListener("message", this.onMessageEvent);
        }
    });

;// CONCATENATED MODULE: ./src/CSVBoxButton.vue?vue&type=script&lang=js
 /* harmony default export */ var src_CSVBoxButtonvue_type_script_lang_js = (CSVBoxButtonvue_type_script_lang_js); 
;// CONCATENATED MODULE: ./node_modules/mini-css-extract-plugin/dist/loader.js??clonedRuleSet-12.use[0]!./node_modules/css-loader/dist/cjs.js??clonedRuleSet-12.use[1]!./node_modules/@vue/vue-loader-v15/lib/loaders/stylePostLoader.js!./node_modules/postcss-loader/dist/cjs.js??clonedRuleSet-12.use[2]!./node_modules/@vue/vue-loader-v15/lib/index.js??vue-loader-options!./src/CSVBoxButton.vue?vue&type=style&index=0&id=22e9acda&prod&scoped=true&lang=css
// extracted by mini-css-extract-plugin

;// CONCATENATED MODULE: ./src/CSVBoxButton.vue?vue&type=style&index=0&id=22e9acda&prod&scoped=true&lang=css

;// CONCATENATED MODULE: ./node_modules/mini-css-extract-plugin/dist/loader.js??clonedRuleSet-12.use[0]!./node_modules/css-loader/dist/cjs.js??clonedRuleSet-12.use[1]!./node_modules/@vue/vue-loader-v15/lib/loaders/stylePostLoader.js!./node_modules/postcss-loader/dist/cjs.js??clonedRuleSet-12.use[2]!./node_modules/@vue/vue-loader-v15/lib/index.js??vue-loader-options!./src/CSVBoxButton.vue?vue&type=style&index=1&id=22e9acda&prod&lang=css
// extracted by mini-css-extract-plugin

;// CONCATENATED MODULE: ./src/CSVBoxButton.vue?vue&type=style&index=1&id=22e9acda&prod&lang=css

;// CONCATENATED MODULE: ./node_modules/@vue/vue-loader-v15/lib/runtime/componentNormalizer.js
/* globals __VUE_SSR_CONTEXT__ */

// IMPORTANT: Do NOT use ES2015 features in this file (except for modules).
// This module is a runtime utility for cleaner component module output and will
// be included in the final webpack user bundle.

function normalizeComponent(
  scriptExports,
  render,
  staticRenderFns,
  functionalTemplate,
  injectStyles,
  scopeId,
  moduleIdentifier /* server only */,
  shadowMode /* vue-cli only */
) {
  // Vue.extend constructor export interop
  var options =
    typeof scriptExports === 'function' ? scriptExports.options : scriptExports

  // render functions
  if (render) {
    options.render = render
    options.staticRenderFns = staticRenderFns
    options._compiled = true
  }

  // functional template
  if (functionalTemplate) {
    options.functional = true
  }

  // scopedId
  if (scopeId) {
    options._scopeId = 'data-v-' + scopeId
  }

  var hook
  if (moduleIdentifier) {
    // server build
    hook = function (context) {
      // 2.3 injection
      context =
        context || // cached call
        (this.$vnode && this.$vnode.ssrContext) || // stateful
        (this.parent && this.parent.$vnode && this.parent.$vnode.ssrContext) // functional
      // 2.2 with runInNewContext: true
      if (!context && typeof __VUE_SSR_CONTEXT__ !== 'undefined') {
        context = __VUE_SSR_CONTEXT__
      }
      // inject component styles
      if (injectStyles) {
        injectStyles.call(this, context)
      }
      // register component module identifier for async chunk inferrence
      if (context && context._registeredComponents) {
        context._registeredComponents.add(moduleIdentifier)
      }
    }
    // used by ssr in case component is cached and beforeCreate
    // never gets called
    options._ssrRegister = hook
  } else if (injectStyles) {
    hook = shadowMode
      ? function () {
          injectStyles.call(
            this,
            (options.functional ? this.parent : this).$root.$options.shadowRoot
          )
        }
      : injectStyles
  }

  if (hook) {
    if (options.functional) {
      // for template-only hot-reload because in that case the render fn doesn't
      // go through the normalizer
      options._injectStyles = hook
      // register for functional component in vue file
      var originalRender = options.render
      options.render = function renderWithStyleInjection(h, context) {
        hook.call(context)
        return originalRender(h, context)
      }
    } else {
      // inject component registration as beforeCreate hook
      var existing = options.beforeCreate
      options.beforeCreate = existing ? [].concat(existing, hook) : [hook]
    }
  }

  return {
    exports: scriptExports,
    options: options
  }
}

;// CONCATENATED MODULE: ./src/CSVBoxButton.vue



;



/* normalize component */

var component = normalizeComponent(
  src_CSVBoxButtonvue_type_script_lang_js,
  render,
  staticRenderFns,
  false,
  null,
  "22e9acda",
  null
  
)

/* harmony default export */ var CSVBoxButton = (component.exports);
;// CONCATENATED MODULE: ./src/index.js

;// CONCATENATED MODULE: ./node_modules/@vue/cli-service/lib/commands/build/entry-lib-no-default.js



module.exports = __webpack_exports__;
/******/ })()
;
//# sourceMappingURL=csvbox-vuejs.common.js.map